package what.the.hell;

import java.io.*;
import java.net.*;
import nuance.so.*;
import nuance.so.dialogmanager.*;
import nuance.util.grammar.*;
import vcommerce.core.util.*;
import vcommerce.sc.*;
import vcommerce.so.*;
import vcommerce.util.*;
import vcommerce.util.context.*;
import vcommerce.util.prompt.*;

public class WeatherInfo extends SODialogManager
{
	public WeatherInfo() throws VCommerceException
	{
		ProcessingObject hello = new ProcessingObject()
		{
			public SpeechObject.Result run(SpeechChannel sc, DialogContext dc, CallState cs, SpeechObject.Result result, VCommerceException exn) throws VCommerceException
			{
				(new PromptAtom("what/the/hell/hello")).appendTo(sc);
				return null;
			}
		};
		SOCity askCity = new SOCity();
		SODate askDate = new SODate();
		askDate.setInitialPrompt(new PromptAtom("what/the/hell/date_initial"));
		askDate.setRejectedPrompt(new PromptAtom("what/the/hell/date_rejected"));
		askDate.setNoSpeechTimeoutPrompt(new PromptAtom("what/the/hell/date_nospeechtimeout"));
		askDate.setHelpPrompt(new PromptAtom("what/the/hell/date_help"));
		ProcessingObject search = new ProcessingObject()
		{
			public SpeechObject.Result run(SpeechChannel sc, DialogContext dc, CallState cs, SpeechObject.Result result, VCommerceException exn) throws VCommerceException
			{
				SOCity.Result askCityResult = (SOCity.Result)dc.getResult("ASK_CITY");
				SODate.Result askDateResult = (SODate.Result)dc.getResult("ASK_DATE");
				//nah, sekarang kita coba query ke CGI buatan temen kita
				try
				{
					URLConnection conn = (new URL("http://127.0.0.1/cgi-bin/weatherinfo.cgi?citycode=" + 
						URLEncoder.encode(askCityResult.getCityCode()) + "&year=" + 
						askDateResult.getYear() + "&month=" + 
						askDateResult.getMonth() + "&day=" + 
						askDateResult.getDayOfMonth()
					)).openConnection();
					conn.setDoOutput(true);
					conn.setDoInput(true);
					conn.setUseCaches(false);
					//anggap saja response dari cgi kita berupa satu baris text, informasi cuaca
					BufferedReader responseReader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
					String infoCuaca = responseReader.readLine();
					//TTS --- Text-To-Speech
					(new TTSPrompt(infoCuaca)).appendTo(sc);
					responseReader.close();
				}
				catch(Exception e)
				{
					(new PromptAtom("what/the/hell/queryfailed")).appendTo(sc);
				}
				return null;
			}
		};
		SOYesNo askAgain = new SOYesNo();
		askAgain.setInitialPrompt(new PromptAtom("what/the/hell/again_initial"));
		askAgain.setRejectedPrompt(new PromptAtom("what/the/hell/again_rejected"));
		askAgain.setNoSpeechTimeoutPrompt(new PromptAtom("what/the/hell/again_nospeechtimeout"));
		askAgain.setHelpPrompt(new PromptAtom("what/the/hell/again_help"));
		ProcessingObject goodbye = new ProcessingObject()
		{
			public SpeechObject.Result run(SpeechChannel sc, DialogContext dc, CallState cs, SpeechObject.Result result, VCommerceException exn) throws VCommerceException
			{
				(new PromptAtom("what/the/hell/goodbye")).appendTo(sc);
				sc.play(false);
				return null;
			}
		};

		askCity.setSOKey("ASK_CITY");
		askDate.setSOKey("ASK_DATE");
		askAgain.setSOKey("ASK_AGAIN");
		
		addState("BILANG_HELLO", hello);
		addState("NANYA_KOTA", askCity);
		addState("NANYA_TANGGAL", askDate);
		addState("LAKUKAN_QUERY", search);
		addState("NANYA_LAGI", askAgain);
		addState("BILANG_GOODBYE", goodbye);

		setInitialState("BILANG_HELLO");

		addTransition("BILANG_HELLO", DONTCARE, "NANYA_KOTA");
		addTransition("NANYA_KOTA", DONTCARE, "NANYA_TANGGAL");
		addTransition("NANYA_TANGGAL", DONTCARE, "LAKUKAN_QUERY");
		addTransition("LAKUKAN_QUERY",DONTCARE, "NANYA_LAGI");
		Conditions.YesCondition yes = new Conditions.YesCondition();
		Condition no = new Conditions.Not(yes);
		addTransition("NANYA_LAGI", yes, "NANYA_KOTA");
		addTransition("NANYA_LAGI", no, "BILANG_GOODBYE");
	}
}

class SOCity extends SODialog
{
	protected SOCity() throws VCommerceException
	{
	}
	protected Grammar createGrammar() throws VCommerceException
	{
		return new FileDynamicGrammar("/grammars/what/the/hell/city.grammar", "CITY", this.getClass());
	}
	protected Playable createInitialPrompt() throws VCommerceException
	{
		return new PromptAtom("what/the/hell/city_initial");
	}
	protected Playable createRejectedPrompt() throws VCommerceException
	{
		return new PromptAtom("what/the/hell/city_rejected");
	}
	protected Playable createNoSpeechTimeoutPrompt() throws VCommerceException
	{
		return new PromptAtom("what/the/hell/city_nospeechtimeout");
	}
	protected Playable createHelpPrompt() throws VCommerceException
	{
		return new PromptAtom("what/the/hell/city_help");
	}
	protected SpeechObject.Result processInterpretation(SpeechChannel sc, DialogContext dc, CallState cs, Interpretation interpretation) throws VCommerceException
	{
		return new Result((String)interpretation.getSlot("citySlot"));
	}

	protected class Result extends SpeechObject.Result
	{
		protected Result(String cityCode)
		{
			setString("CITY_CODE", cityCode);
		}
		protected String getCityCode()
		{
			return getString("CITY_CODE");
		}
		public String toString()
		{
			return getCityCode();
		}
		public void appendTo(PromptPlayer player) throws VCommerceException
		{
		}
	}
}